


void drawInstructionsPanel() {

  if (pickerMode == 0) {
    eyedropper = loadImage ("pickermodeff.png");
  } else { 
    eyedropper = loadImage ("pickermodeon.png");
  }  

  smooth();
  instructionsFont = loadFont("AbsolutPro-ThinIt-14.vlw");
  smallInstructionsFont = loadFont("AbsolutPro-ThinIt-12.vlw");

  // background
  fill (130, 132, 129);
  noStroke();
  rect (instructionsX, instructionsY, width, 95);       

  fill (170, 20);
  noStroke();
  rect (instructionsX, instructionsY, width, 90);       

  fill (220, 28);
  noStroke();
  rect (instructionsX, instructionsY, width, 9);

  /*
   fill (214,20);
   noStroke();
   rect (0,610,width,3);
   */

  textAlign(LEFT);



  // draw the logos  
  tint(255, 100);
  //image (roundedshape, instructionsX+logoBlockX+8, instructionsY+logoBlockY+12,168, 71);
  tint(255, 95);
  image (logo, instructionsX+logoBlockX+26, instructionsY+logoBlockY+21, 145, 35);

  fill(0, 199);
  textFont(smallInstructionsFont, 12);
  text("from Slopware", instructionsX+logoBlockX+59, instructionsY+logoBlockY+62);      

  fill(252, 160, 246);
  textFont(smallInstructionsFont, 12);
  text("from Slopware", instructionsX+logoBlockX+59, instructionsY+logoBlockY+63);


  // saveState panel
  // saveState1 = loadImage ("state1.jpg");
  fill(255, 255);
  tint(255, 230);
  image (saveState1, saveStatePanelX, saveStatePanelY+19, 65, 52);     // was width/2 -293

  // saveState2 = loadImage ("state2.jpg");
  fill(255, 255);
  tint(255, 255);
  image (saveState2, saveStatePanelX+72, saveStatePanelY+19, 65, 52);

  //  saveState3 = loadImage ("state3.jpg");
  fill(255, 255);
  tint(255, 255);
  image (saveState3, saveStatePanelX+144, saveStatePanelY+19, 65, 52);

  fill (132, 135, 132);
  rect (saveStatePanelX, saveStatePanelY+65, 226, 20);

  smooth();
  fill(0, 155);
  textFont(instructionsFont, 8);
  text ("REVERT", saveStatePanelX+20, saveStatePanelY+80);  
  text ("REVERT", saveStatePanelX+92, saveStatePanelY+80);  
  text ("REVERT", saveStatePanelX+164, saveStatePanelY+80);  

  fill(40);
  textAlign (LEFT);
  textFont(instructionsFont, 11);
  text ("~ to =    brush size presets", directionsPanelX-10, directionsPanelY+21);
  text ("B         next brush shape", directionsPanelX, directionsPanelY+36);


  if (width >1100) {

    imageMode (CENTER);

    fill(200, 30);
    rect (directionsPanelX+156, directionsPanelY+5, 65, 65);


    tint(50);

    if (whichBrush == 0 ) { 
      fill(0, 200, 0, 150);
    } 
    ellipse (directionsPanelX+169, directionsPanelY+18, 15, 15);

    if (whichBrush == 1 ) { 
      tint(0, 200, 0, 150);
    } 
    image (brush1icon, directionsPanelX +189, directionsPanelY+18, 20, 20);

    tint(50);

    if (whichBrush == 2 ) { 
      tint(0, 200, 0, 150);
    } 
    image (brush2icon, directionsPanelX +209, directionsPanelY+18, 20, 20);
    tint(50);

    if (whichBrush == 3 ) { 
      tint(0, 200, 0, 150);
    } 
    image (brush3icon, directionsPanelX +169, directionsPanelY+38, 20, 20);
    tint(50);

    if (whichBrush == 4 ) { 
      tint(0, 200, 0, 150);
    } 
    image (brush4icon, directionsPanelX +189, directionsPanelY+38, 20, 20);
    tint(50);

    if (whichBrush == 5 ) { 
      tint(0, 200, 0, 150);
    } 
    image (brush5icon, directionsPanelX +209, directionsPanelY+38, 20, 20);

    tint(50);
    if (whichBrush == 6 ) { 
      tint(0, 200, 0, 150);
    }
    image (brush6icon, directionsPanelX +169, directionsPanelY+58, 20, 20);
    tint(50);


    if (whichBrush == 7 ) { 
      tint(0, 200, 0, 150);
    }
    image (brush7icon, directionsPanelX +189, directionsPanelY+58, 20, 20);
    tint(50);


    if (whichBrush == 8 ) { 
      tint(0, 200, 0, 150);
    }
    image (brush8icon, directionsPanelX +209, directionsPanelY+58, 13, 13);
    tint(50);
  }


  imageMode (CORNER);
  fill(0, 150);

  text ("<-- R        random lines", directionsPanelX-23, directionsPanelY+50);      // was 67
  text ("single", directionsPanelX+32, directionsPanelY+63);
  text ("automatic", directionsPanelX+81, directionsPanelY+63);



  // leftDirectionsPanelX

  text ("undo last mark     U", leftDirectionsPanelX+22, directionsPanelY+22); 
  text ("save image     S", leftDirectionsPanelX+37, directionsPanelY+36);
  text ("load image file     F", leftDirectionsPanelX+23, directionsPanelY+50);
  text ("hold to connect dots      L", leftDirectionsPanelX, directionsPanelY+64);


  fill(255, 100);
  ellipse (directionsPanelX+67, directionsPanelY+59, 8, 8);
  ellipse (directionsPanelX+134, directionsPanelY+59, 8, 8);


  if (randomMode == 1) {
    {
      fill(20, 255, 20, 150);
      ellipse (directionsPanelX+67, directionsPanelY+59.5, 6, 6);

      fill(20, 55, 20, 200);
      ellipse (directionsPanelX+134, directionsPanelY+59.5, 7, 7);
    }
  } else 
  {
    fill(20, 55, 20, 200);
    ellipse (directionsPanelX+67, directionsPanelY+59.5, 7, 7);

    fill(20, 255, 20, 200);
    ellipse (directionsPanelX+134, directionsPanelY+59.5, 6, 6);
  }

  // draw dotted line to show 1/2 way point
  fill (141);
  int dottedLineColor = 141;

  for (int x=5; x<100; x=x+8) {

    if (dottedLineColor <101) {
      dottedLineColor = 131;  // make it blend with background
    } else {
      dottedLineColor = 60;
    }

    fill (dottedLineColor);
    int yValue = instructionsY+x;
    int yValuePlus = yValue + 2;
    rect ((width/2)-1, yValue, 3, yValuePlus);
  }   

  // draw the random mark swath grey shape
  fill(255, 20);
  rect(width/2-40, swathIndicatorCenterY-25, 80, 50);

  // random mark swath adjuster  
  strokeWeight(1);
  stroke(10, 220, 10, 100);
  fill(0, 255, 0, 20);


  if (mouseX==0 && mouseY==0) {
    swathIndicatorX = width/2-50;
    swathIndicatorY = swathIndicatorCenterY-35;
  }

  rect(swathIndicatorX, swathIndicatorY, swathIndicatorWidth, swathIndicatorHeight);

  // brush size indicator
  noFill();
  stroke(255, 100);
  if (width > 1000) {
  }
  ellipse (brushSizeX-5, brushSizeY+8+brushSize/2, brushSize, brushSize);

  fill(30);
  textSize(12);
  text ("arrows", brushSizeX-23, brushSizeY-22);
  text ("< adjust >", brushSizeX-33, brushSizeY-10);
  textSize (12);
  text ("brush size", brushSizeX-29, brushSizeY+2);


  // draw color picker
  tint(255, 100); 
  image(dropshadow, colorPickerPanelX, colorPickerPanelY+7, 230, 120);    // was 242

  // the color picker graphic
  tint(255, 255); 
  image(colorPicker, colorPickerPanelX+3, colorPickerPanelY+1); 

  stroke(1);
  strokeWeight(1);

  // draw the small swatch that represents the currently picked color
  fill(theCurrentR, theCurrentG, theCurrentB, 255);
  rect(colorPickerPanelX+10, colorPickerPanelY+52, 16, 16);

  // draw the small swatch that represents the currently picked color
  fill(theCurrentR, theCurrentG, theCurrentB, 255);
  rect(colorPickerPanelX+8, colorPickerPanelY+6, 15, 15);

  // draw the question mark on the color swatch while in pickerMode = 1
  if (pickerMode == 1) {

    textSize(12);
    fill(0);
    text("?", colorPickerPanelX+14, colorPickerPanelY+19);

    // grey out colorpicker image while eyedropper is in effect
    noStroke();
    fill(180, 190);
    rect(colorPickerPanelX+45, colorPickerPanelY+5, 180, 64);
  }
  //  change cursor to eyedropper when pickerMode == 1  and while mouse is over the color picker
  // transparency icon: draw the small swatch the represents the current alpha setting
  tint(255, 255-theCurrentA);

  image(grid, colorPickerPanelX+11, colorPickerPanelY+53, 15, 15);

  // alpha background shape
  // stroke(6,7,5,169);
  // fill(200,185);
  // rect (800,672,137,18); 

  // green indicator
  noStroke();
  fill (0, 233, 0, 190);
  float lengthOfGreenRect = theCurrentA/2+2;
  if (lengthOfGreenRect >165) {
    lengthOfGreenRect = 165;
  }

  rect (colorPickerPanelX+58, colorPickerPanelY+73, lengthOfGreenRect, 8);

  // map alphaReadout
  int alphaReadout = (int)map(theCurrentA, 0, 255, 0, 100);
  if (alphaReadout >100) {
    alphaReadout = 100;
  }
  if (alphaReadout <0) {
    alphaReadout = 0;
  }

  fill(0, 255);
  smooth();
  textAlign(CENTER);
  textFont(instructionsFont, 9);
  text (alphaReadout + "%", colorPickerPanelX+18, colorPickerPanelY+49);
  fill(0, 200);
  textAlign(CENTER);
  textFont(instructionsFont, 10);
  text ("OPACITY", colorPickerPanelX+34, colorPickerPanelY+81);
  // text ("COLOR",1016,853);
  // fill (200,100,00);
  // ellipse (1064+theCurrentA/2,886,7,12);

  if (savingImage == 1) {

    textFont(instructionsFont, 10);

    fill(255, saveLabelFade);
    text ("Image saving in Symmetron folder", saveStatePanelX+300, saveStatePanelY+91);
  }

  // these are the rollover effects


  /// is the mouse over the eyedropper icon?

  if (mouseX > colorPickerPanelX+3  &&  mouseX < colorPickerPanelX+24 ) {
    if (mouseY > colorPickerPanelY+24  && mouseY < colorPickerPanelY+42 ) {  

      eyedropper = loadImage ("pickermodeon.png");

      if (mousePressed) {

        if (pickerMode == 0) {
          pickerMode = 1;
        } else {


          pickerMode = 0;
          eyedropper = loadImage ("pickermodeff.png");
        }
      }
    }
  }

  // did the user rollover saveState1
  if (mouseX > saveStatePanelX  &&  mouseX < saveStatePanelX+69) {
    if (mouseY > saveStatePanelY+20 && mouseY < saveStatePanelY+64) {   
      textFont(instructionsFont, 10);
      textAlign (CENTER);
      fill(255, 200);
      text ("SAVE", saveStatePanelX+35, saveStatePanelY+37);
      text ("CURRENT", saveStatePanelX+35, saveStatePanelY+46);
      text ("STATE", saveStatePanelX+35, saveStatePanelY+ 55);
    }
  }

  // did the user rollover saveState2
  if (mouseX > saveStatePanelX+75  &&  mouseX < saveStatePanelX+142) {
    if (mouseY > saveStatePanelY+20 && mouseY < saveStatePanelY+64) {   
      textFont(instructionsFont, 10);
      textAlign (CENTER);
      fill(255, 200);
      text ("SAVE", saveStatePanelX+105, saveStatePanelY+37);
      text ("CURRENT", saveStatePanelX+105, saveStatePanelY+46);
      text ("STATE", saveStatePanelX+105, saveStatePanelY+55);
    }
  }

  // did the user rollover saveState3
  if (mouseX > saveStatePanelX+156  &&  mouseX < saveStatePanelX+229) {
    if (mouseY > saveStatePanelY+20 && mouseY < saveStatePanelY+64) {   
      textFont(instructionsFont, 10);
      textAlign (CENTER);
      fill(255, 200);
      text ("SAVE", saveStatePanelX+177, saveStatePanelY+37);
      text ("CURRENT", saveStatePanelX+177, saveStatePanelY+46);
      text ("STATE", saveStatePanelX+177, saveStatePanelY+55);
    }
  }    

  // did the user click on revert state 1
  if (mouseX > saveStatePanelX+10  &&  mouseX < saveStatePanelX+70) {
    if (mouseY > saveStatePanelY+69 && mouseY < saveStatePanelY+83) {  

      textFont(instructionsFont, 8);
      textAlign (CENTER);
      fill (255);
      text ("REVERT", saveStatePanelX+35, saveStatePanelY+80);  

      if (mousePressed) {

        saveState1 = loadImage ("state1.jpg");
        fill(255, 255);
        tint(255, 255);
        image (saveState1, 0, 0);
      }
    }
  }

  // did the user click on revert state 2
  if (mouseX > saveStatePanelX+91  &&  mouseX < saveStatePanelX+172) {
    if (mouseY > saveStatePanelY+69 && mouseY < saveStatePanelY+83) {  

      textFont(instructionsFont, 8);
      textAlign (CENTER);
      fill (255);
      text ("REVERT", saveStatePanelX+105, saveStatePanelY+ 80);  

      if (mousePressed) {

        saveState2 = loadImage ("state2.jpg");
        fill(255, 255);
        tint(255, 255);
        image (saveState2, 0, 0);
      }
    }
  }

  // did the user click on revert state 3
  if (mouseX > saveStatePanelX+164  &&  mouseX < saveStatePanelX+240) {
    if (mouseY > saveStatePanelY+69 && mouseY < saveStatePanelY+83) {  
      textFont(instructionsFont, 8);
      textAlign (CENTER);
      fill (255);
      text ("REVERT", saveStatePanelX+177, saveStatePanelY+80);  

      if (mousePressed) {
        saveState3 = loadImage ("state3.jpg");
        fill(255, 255);
        tint(255, 255);
        image (saveState3, 0, 0);
      }
    }
  }

  // eyedropper
  fill(255, 255);
  tint(255, 255);
  image (eyedropper, colorPickerPanelX+12, colorPickerPanelY+25, 11, 11);

  if (pickerMode == 1) {

    fill (0, 180);

    textSize (12);
    text ("select color from above", colorPickerPanelX+129, colorPickerPanelY+39);
    //text ("from above", 809, 654);

    if (mouseY < instructionsY) {
      eyedropper = loadImage ("pickermodeff.png");
      cursor (eyedropper, 1, 14);
    }
  } else {

    if (mouseX > colorPickerPanelX +30) {
      if (mouseY >instructionsY) {
        cursor (eyedropper, 1, 14);
      }
    } else {
      // cursor(CROSS);
    }
  }

  if (keyPressed) {

    if (key == 's') {
      if (savingImage == 0 ) {
        savingImage = 1;
        saveFrame ("symmetron-####.png");
        // lastTime = millis();  
        println("s pressed - another image saved");

        saveLabelFade = 255;
      }
    }
  }


  if (saveLabelFade >0 && savingImage == 1) {
    saveLabelFade = saveLabelFade  - 2;
  }

  if (saveLabelFade <1 ) {
    saveLabelFade = 255;
    savingImage = 0;
  }

  // println ("saveLabelFade = " +saveLabelFade);
}
